' Copyright (c) 2006 Axon Instruments all rights reserved.
' Interface definition for AxoclampDriver.dll

#ifndef __FB_WIN32__
  #error 666: Target host must be a Windows PC !
#elseif defined(__FB_64BIT__)
  #error 666: Target host must be x86 !
#endif

#include once "windows.bi"

#inclib "AxoclampDriver"



' The handle type declaration.
#define DECLARE_HANDLE(name) type name##__ : as integer unused : end type : type name as name##__ ptr
DECLARE_HANDLE(HAXC)
#define AXC_APIVERSION       1,0,0,56
#define AXC_APIVERSION_STR "1.0.0.56"

type AXC_PropertyRange
  as double dValMin
  as double dValMax
  as long   nValMin
  as long   nValMax
end type

type AXC_SignalSettings
  as long     bSave
  as double   dGain
  as double   dLPF
  as double   dHPF
  as double   dZeroLevel 
  as long     bZeroEnable
  as uinteger uLPFType 
end type

type AXC_PropertyRules
  as long bMode
  as long bAutoEnable
  as long bAutoPolarity
  as long bAutoSource
  as long bAutoThreshold
  as long bAutoICReturn
  as long bAutoICDelay
  as long bAutoVCDelay
  as long bHoldingEnable
  as long bHoldingLevel
  as long bExtCmdEnable
  as long bTestSignalEnable
  as long bTestSignalAmplitude
  as long bTestSignalFrequency
  as long bPulse
  as long bPulseDuration
  as long bPulseAmplitude
  as long bBuzz
  as long bBuzzDuration
  as long bBuzzAmplitude
  as long bAutoPipetteOffset
  as long bPipetteOffsetLock
  as long bPipetteOffset
  as long bOscKillerEnable
  as long bOscKillerMethod
  as long bAutoBridge
  as long bBridgeLock
  as long bBridgeEnable
  as long bBridgeLevel
  as long bClearElectrode
  as long bCapNeutEnable
  as long bCapNeutLevel
  as long bTrackEnable
  as long bTrackLevel
  as long bTrackSpeed
  as long bScaledOutputSignal
  as long bScaledOutputSignalGain
  as long bScaledOutputSignalLPF
  as long bScaledOutputSignalLPFType
  as long bScaledOutputSignalHPF
  as long bAutoScaledOutputZero
  as long bScaledOutputZeroEnable
  as long bScaledOutputZeroLevel
  as long bSamplePeriod
  as long bLoopGain
  as long bLoopLag
  as long bDCRestoreEnable
  as long bAudioSignal
end type

type AXC_MeterData
  as double dMeter1
  as double dMeter2
  as double dMeter3
  as double dMeter4
  as long bOvldMeter1
  as long bOvldMeter2
  as long bOvldMeter3
  as long bOvldMeter4
  as long bPowerFail
  as long bPresenceChan1
  as long bPresenceChan2
  as long bPresenceAux1
  as long bPresenceAux2
  as long bIsVClampChan1
  as long bIsVClampChan2
  as long bOscKillerChan1
  as long bOscKillerChan2
end type

type AXC_Signal
  as uinteger    uChannel
  as uinteger    uID
  as zstring ptr pszName
  as long        bValid
end type

'  ==============================================================================================
'   Error codes
'  ==============================================================================================
'   General error codes.
const as integer AXC_ERR_NOERROR                         = 0
const as integer AXC_ERR_BASE                            = 9000
const as integer AXC_ERR_OUTOFMEMORY                     = AXC_ERR_BASE + 1
const as integer AXC_ERR_NOTOPEN                         = AXC_ERR_BASE + 2
const as integer AXC_ERR_ALREADYOPEN                     = AXC_ERR_BASE + 3
const as integer AXC_ERR_ALREADYCLOSED                   = AXC_ERR_BASE + 4
const as integer AXC_ERR_BUFFEROVERFLOW                  = AXC_ERR_BASE + 5
const as integer AXC_ERR_BADCMDSYNTAX                    = AXC_ERR_BASE + 6
const as integer AXC_ERR_UNKNOWNDEVICE                   = AXC_ERR_BASE + 7
const as integer AXC_ERR_PROPERTYNOTFOUND                = AXC_ERR_BASE + 8
const as integer AXC_ERR_INITIALIZEFAILED                = AXC_ERR_BASE + 9
const as integer AXC_ERR_INVALIDDLLHANDLE                = AXC_ERR_BASE + 10
const as integer AXC_ERR_INVALIDPARAMETER                = AXC_ERR_BASE + 11
const as integer AXC_ERR_INVALIDCHANNEL                  = AXC_ERR_BASE + 12
const as integer AXC_ERR_INVALIDMODE                     = AXC_ERR_BASE + 13
const as integer AXC_ERR_INVALIDSIGNAL                   = AXC_ERR_BASE + 14
const as integer AXC_ERR_INVALIDMETER                    = AXC_ERR_BASE + 15
const as integer AXC_ERR_INVALIDHEADSTAGE                = AXC_ERR_BASE + 16
const as integer AXC_ERR_INVALIDPIPETTEOFFSET            = AXC_ERR_BASE + 17
const as integer AXC_ERR_INVALIDBRIDGEBALANCE            = AXC_ERR_BASE + 18
const as integer AXC_ERR_PIPETTEOFFSETLOCKED             = AXC_ERR_BASE + 19
const as integer AXC_ERR_BRIDGELOCKED                    = AXC_ERR_BASE + 20
const as integer AXC_ERR_TRIGGERCMDFAILED                = AXC_ERR_BASE + 21
const as integer AXC_ERR_CANNOTUSEVGHEADSTAGEONMAINPORT  = AXC_ERR_BASE + 22
const as integer AXC_ERR_CANNOTUSEHOLDINGWITHTRACK       = AXC_ERR_BASE + 23
const as integer AXC_ERR_CANNOTUSETRACKWITHHOLDING       = AXC_ERR_BASE + 24
const as integer AXC_ERR_VALUEOUTOFRANGE                 = AXC_ERR_BASE + 25
const as integer AXC_ERR_INVALIDCONFIGFILE               = AXC_ERR_BASE + 26

const as integer AXC_ERR_FIRSTHIDERROR                   = AXC_ERR_BASE + 200

'  ==============================================================================================
'   Channel identifiers
'  ==============================================================================================
const as uinteger AXC_CHAN_1                 = 0
const as uinteger AXC_CHAN_2                 = 1
const as uinteger AXC_MAX_CHANNELS           = 2

const as uinteger AXC_CHAN_ALL               = 2
const as uinteger AXC_CHAN_NONE              = 3

'  ==============================================================================================
'   Scaled Output Channel identifiers
'  ==============================================================================================
const as uinteger AXC_SOCHAN_1               = 0
const as uinteger AXC_SOCHAN_2               = 1
const as uinteger AXC_MAX_SOCHANNELS         = 2

'  ==============================================================================================
'   Mode identifiers
'  ==============================================================================================
const as uinteger AXC_MODE_IZERO             = 0
const as uinteger AXC_MODE_ICLAMP            = 1
const as uinteger AXC_MODE_DCC               = 2   
const as uinteger AXC_MODE_HVIC              = 3   
const as uinteger AXC_MODE_DSEVC             = 4
const as uinteger AXC_MODE_TEVC              = 5
const as uinteger AXC_MAX_MODES              = 6

const as uinteger AXC_MODE_NONE              = 6
const as uinteger AXC_MODE_ALL               = 7

'  ==============================================================================================
'   Hardware Type Identifiers
'  ==============================================================================================
const as uinteger ACX_HW_TYPE_AC900A      = 0
const as uinteger ACX_HW_TYPE_NUMCHOICES  = 1
const as uinteger ACX_HW_TYPE_CURRENT     = ACX_HW_TYPE_AC900A

'  ==============================================================================================
'   Hardware Type Names
'  ==============================================================================================
dim shared as const zstring ptr ACX_HW_TYPE_NAMES(ACX_HW_TYPE_NUMCHOICES-1) = {@"Axoclamp 900A"}

'  ==============================================================================================
'   Default strings
'  ==============================================================================================
dim shared as const zstring ptr g_pszConfigDefault   = @"AXC_CONFIG_DEFAULT"
dim shared as const zstring ptr c_szDemoSerialNumber = @"Demo"

'  ==============================================================================================
'   Auto identifiers
'  ==============================================================================================

'   voltage clamp options
const as uinteger AXC_AUTO_TEVC              = 0
const as uinteger AXC_AUTO_DSEVC             = 1

'   "return to IC" options
const as uinteger AXC_AUTO_ICRETURN_MANUAL   = 0
const as uinteger AXC_AUTO_ICRETURN_EXTERNAL = 1
const as uinteger AXC_AUTO_ICRETURN_DELAY    = 2

'   Polarity options
const as uinteger AXC_AUTO_POLARITY_NTOP     = 0
const as uinteger AXC_AUTO_POLARITY_PTON     = 1

'   Signal source options
const as uinteger AXC_AUTO_SOURCE_EXTERNAL   = 0
const as uinteger AXC_AUTO_SOURCE_INTERNAL   = 1

'  ==============================================================================================
'   Signal identifiers
'  ==============================================================================================
const as uinteger AXC_SIGNAL_ID_XICMD1      = 0
const as uinteger AXC_SIGNAL_ID_ICMD1       = 1
const as uinteger AXC_SIGNAL_ID_10V1        = 2
const as uinteger AXC_SIGNAL_ID_I1          = 3
const as uinteger AXC_SIGNAL_ID_MON         = 4
const as uinteger AXC_SIGNAL_ID_RMP         = 5
const as uinteger AXC_SIGNAL_ID_XICMD2      = 6
const as uinteger AXC_SIGNAL_ID_ICMD2       = 7
const as uinteger AXC_SIGNAL_ID_10V2        = 8
const as uinteger AXC_SIGNAL_ID_I2          = 9
const as uinteger AXC_SIGNAL_ID_DIV10V2     = 10
const as uinteger AXC_SIGNAL_ID_DIV10I2     = 11
const as uinteger AXC_SIGNAL_ID_XVCMD       = 12
const as uinteger AXC_SIGNAL_ID_VCMD        = 13
const as uinteger AXC_SIGNAL_ID_10AUX1      = 14
const as uinteger AXC_SIGNAL_ID_10AUX2      = 15
const as uinteger AXC_SIGNAL_ID_10mV        = 16
const as uinteger AXC_SIGNAL_ID_GND         = 17

'  ==============================================================================================
'   Signal names
'  ==============================================================================================
#define AXC_SIGNAL_NAME_XICMD1  @"Headstage 1, External Current Command"
#define AXC_SIGNAL_NAME_ICMD1   @"Headstage 1, Current Command"
#define AXC_SIGNAL_NAME_10V1    @"Headstage 1, Membrane Potential"
#define AXC_SIGNAL_NAME_I1      @"Headstage 1, Membrane Current"
#define AXC_SIGNAL_NAME_MON     @"Headstage 1, DCC Monitor"
#define AXC_SIGNAL_NAME_RMP     @"Resting Membrane Potential"
#define AXC_SIGNAL_NAME_XICMD2  @"Headstage 2, External Command Current"
#define AXC_SIGNAL_NAME_ICMD2   @"Headstage 2, Command Current"
#define AXC_SIGNAL_NAME_10V2    @"Headstage 2, Membrane Potential"
#define AXC_SIGNAL_NAME_I2      @"Headstage 2, Membrane Current"
#define AXC_SIGNAL_NAME_DIV10V2 @"Headstage 2, 0.1x Membrane Potential"
#define AXC_SIGNAL_NAME_DIV10I2 @"Headstage 2, 0.1x Membrane Current"
#define AXC_SIGNAL_NAME_XVCMD   @"External Command Potential"
#define AXC_SIGNAL_NAME_VCMD    @"Command Potential"
#define AXC_SIGNAL_NAME_10AUX1  @"Auxiliary 1"
#define AXC_SIGNAL_NAME_10AUX2  @"Auxiliary 2"
#define AXC_SIGNAL_NAME_10mV    @"10mV DC Test signal "
#define AXC_SIGNAL_NAME_GND     @"Ground "

'===================================================================================

const as uinteger AXC_MAX_SIGNALS           = 18

dim shared as AXC_Signal s_Signals(AXC_MAX_SIGNALS-1) => { _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_XICMD1,  AXC_SIGNAL_NAME_XICMD1,  TRUE ), _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_ICMD1,   AXC_SIGNAL_NAME_ICMD1,   TRUE ), _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_10V1,    AXC_SIGNAL_NAME_10V1,    TRUE ), _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_I1,      AXC_SIGNAL_NAME_I1,      TRUE ), _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_MON,     AXC_SIGNAL_NAME_MON,     TRUE ), _
   ( AXC_CHAN_1,    AXC_SIGNAL_ID_RMP,     AXC_SIGNAL_NAME_RMP,     TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_XICMD2,  AXC_SIGNAL_NAME_XICMD2,  TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_ICMD2,   AXC_SIGNAL_NAME_ICMD2,   TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_10V2,    AXC_SIGNAL_NAME_10V2,    TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_I2,      AXC_SIGNAL_NAME_I2,      TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_DIV10V2, AXC_SIGNAL_NAME_DIV10V2, TRUE ), _
   ( AXC_CHAN_2,    AXC_SIGNAL_ID_DIV10I2, AXC_SIGNAL_NAME_DIV10I2, TRUE ), _
   ( AXC_CHAN_ALL,  AXC_SIGNAL_ID_XVCMD,   AXC_SIGNAL_NAME_XVCMD,   TRUE ), _
   ( AXC_CHAN_ALL,  AXC_SIGNAL_ID_VCMD,    AXC_SIGNAL_NAME_VCMD,    TRUE ), _
   ( AXC_CHAN_NONE, AXC_SIGNAL_ID_10AUX1,  AXC_SIGNAL_NAME_10AUX1,  TRUE ), _
   ( AXC_CHAN_NONE, AXC_SIGNAL_ID_10AUX2,  AXC_SIGNAL_NAME_10AUX2,  TRUE ), _
   ( AXC_CHAN_NONE, AXC_SIGNAL_ID_10mV,    AXC_SIGNAL_NAME_10mV,    TRUE ), _
   ( AXC_CHAN_NONE, AXC_SIGNAL_ID_GND,     AXC_SIGNAL_NAME_GND,     TRUE ) _
 }

'  ==============================================================================================
'   Signal Gains - fixed
'  ==============================================================================================
const as double AXC_SIGNAL_GAIN_X100    = 1.0e+2
const as double AXC_SIGNAL_GAIN_X10     = 1.0e+1
const as double AXC_SIGNAL_GAIN_X1      = 1.0e+0
const as double AXC_SIGNAL_GAIN_DIV10   = 1.0e-1

'  ==============================================================================================
'   External Command Sensitivity 
'  ==============================================================================================
const as double AXC_EXTCMD_RANGE_VOLTS  = 0.10
const as double AXC_EXTCMD_GAIN_VC      = 0.02   '   V/V

'  ==============================================================================================
'   LPF filter type identifiers
'  ==============================================================================================
const as uinteger AXC_SIGNAL_LPFTYPE_BESSEL      = 0
const as uinteger AXC_SIGNAL_LPFTYPE_BUTTERWORTH = 1

'  ==============================================================================================
'   oscillation killer identifiers
'  ==============================================================================================
const as uinteger AXC_OSCKILLER_METHOD_DISABLE   = 0
const as uinteger AXC_OSCKILLER_METHOD_REDUCE    = 1

'  ==============================================================================================
'   meter identifiers
'  ==============================================================================================

'   Meter Mux IDs
const as uinteger AXC_MAX_METERS              = 4

const as uinteger AXC_METER_MUX_1             = 0
const as uinteger AXC_METER_MUX_2             = 1
const as uinteger AXC_METER_MUX_3             = 2
const as uinteger AXC_METER_MUX_4             = 3

'   Meter signals
const as uinteger AXC_METER_SIGNAL_MIN        = 0
const as uinteger AXC_METER_SIGNAL_MAX        = 40

const as uinteger AXC_METER_SIGNAL_CH1_XICMD  = 0  '   Ch1 External command current
const as uinteger AXC_METER_SIGNAL_CH1_ICMD   = 1  '   Ch1 Headstage command current
const as uinteger AXC_METER_SIGNAL_CH1_I      = 2  '   Ch1 Headstage current
const as uinteger AXC_METER_SIGNAL_CH1_10V    = 3  '   Ch1 Headstage voltage x10
const as uinteger AXC_METER_SIGNAL_SO1        = 4  '   Scaled output 1 voltage (either channel)
const as uinteger AXC_METER_SIGNAL_XVCMD      = 5  '   External command voltage (either channel)
const as uinteger AXC_METER_SIGNAL_VCMD       = 6  '   Headstage command voltage (either channel)
const as uinteger AXC_METER_SIGNAL_RMP        = 7  '   Resting Membrane potential (prior to closing TEVC feedback loop)
const as uinteger AXC_METER_SIGNAL_CH1_VCRES  = 8  '   Ch1 Voltage clamp resistance
const as uinteger AXC_METER_SIGNAL_CH1_ICRES  = 9  '   Ch1 Current clamp resistance

const as uinteger AXC_METER_SIGNAL_CH2_XICMD  = 10 '   Ch2 External command current
const as uinteger AXC_METER_SIGNAL_CH2_ICMD   = 11 '   Ch2 Headstage command current
const as uinteger AXC_METER_SIGNAL_CH2_I      = 12 '   Ch2 Headstage current
const as uinteger AXC_METER_SIGNAL_CH2_DIV10I = 13 '   Ch2 Headstage current x0.1
const as uinteger AXC_METER_SIGNAL_CH2_10V    = 14 '   Ch2 Headstage voltage x10
const as uinteger AXC_METER_SIGNAL_CH2_DIV10V = 15 '   Ch2 Headstage voltage x0.1
const as uinteger AXC_METER_SIGNAL_SO2        = 16 '   Scaled output 2 voltage (either channel)
const as uinteger AXC_METER_SIGNAL_UNUSED1    = 17 '   Not used
const as uinteger AXC_METER_SIGNAL_CH2_VCRES  = 18 '   Ch2 Voltage clamp resistance
const as uinteger AXC_METER_SIGNAL_CH2_ICRES  = 19 '   Ch2 Current clamp resistance

const as uinteger AXC_METER_SIGNAL_10AUX1     = 20 '   Auxiliary 1 x10
const as uinteger AXC_METER_SIGNAL_MON        = 21 '   Monitor signal
const as uinteger AXC_METER_SIGNAL_10AUX2     = 22 '   Auxiliary 2 x10
const as uinteger AXC_METER_SIGNAL_VREF       = 23 '   Voltage reference
const as uinteger AXC_METER_SIGNAL_1V         = 24 '   1V supply
const as uinteger AXC_METER_SIGNAL_GND        = 25 '   Analog Ground
const as uinteger AXC_METER_SIGNAL_UNUSED2    = 26 '   Not used
const as uinteger AXC_METER_SIGNAL_UNUSED3    = 27 '   Not used
const as uinteger AXC_METER_SIGNAL_PLUS200V   = 28 '   +200V supply
const as uinteger AXC_METER_SIGNAL_MINUS200V  = 29 '   -200V supply

const as uinteger AXC_METER_SIGNAL_PLUS15V    = 30 '   +15V supply
const as uinteger AXC_METER_SIGNAL_MINUS15V   = 31 '   -15V supply
const as uinteger AXC_METER_SIGNAL_PLUS5V     = 32 '   +5V  supply
const as uinteger AXC_METER_SIGNAL_MINUS5V    = 33 '   -5V  supply
const as uinteger AXC_METER_SIGNAL_PLUS35V    = 34 '   +35V supply
const as uinteger AXC_METER_SIGNAL_MINUS35V   = 35 '   -35V supply
const as uinteger AXC_METER_SIGNAL_ID1        = 36 '   ?
const as uinteger AXC_METER_SIGNAL_ID2        = 37 '   ?
const as uinteger AXC_METER_SIGNAL_ID3        = 38 '   ?
const as uinteger AXC_METER_SIGNAL_ID4        = 39 '   ?
const as uinteger AXC_METER_SIGNAL_UNUSED4    = 40 '   Not used
                   
'  ==============================================================================================
'   Clear Electrode identifiers
'  ==============================================================================================
const as uinteger AXC_CLEAR_OFF                  = 0   '   internal use only
const as uinteger AXC_CLEAR_POLARITY_POSITIVE    = 1
const as uinteger AXC_CLEAR_POLARITY_NEGATIVE    = 2

'  ==============================================================================================
'   Headstage types - 6 to 19 reserved for future headstages
'  ==============================================================================================
const as uinteger AXC_HEADSTAGE_TYPE_HS9_ADAPTER          = 0   '   custom headstage, user entered Rf and Ci value
const as uinteger AXC_HEADSTAGE_TYPE_HS9_x10uA            = 1   '   Rf = 1M
const as uinteger AXC_HEADSTAGE_TYPE_HS9_x1uA             = 2   '   Rf = 10M
const as uinteger AXC_HEADSTAGE_TYPE_HS9_x100nA           = 3   '   Rf = 100M
const as uinteger AXC_HEADSTAGE_TYPE_VG9_x10uA            = 4   '   Rf = 1M
const as uinteger AXC_HEADSTAGE_TYPE_VG9_x100uA           = 5   '   Rf = 0.1M
const as uinteger AXC_HEADSTAGE_TYPE_NONE                 = 20  '   headstage not connected

'  ==============================================================================================
'   Headstage names
'  ==============================================================================================
#define AXC_HEADSTAGE_NAME_HS9_ADAPTER @"Custom"        '   custom headstage, user entered Rf value
#define AXC_HEADSTAGE_NAME_HS9_x10uA   @"HS-9A x10"     '   Rf = 1M
#define AXC_HEADSTAGE_NAME_HS9_x1uA    @"HS-9A x1"      '   Rf = 10M
#define AXC_HEADSTAGE_NAME_HS9_x100nA  @"HS-9A x0.1"    '   Rf = 100M
#define AXC_HEADSTAGE_NAME_VG9_x10uA   @"VG-9A x10"     '   Rf = 1M
#define AXC_HEADSTAGE_NAME_VG9_x100uA  @"VG-9A x100"    '   Rf = 0.1M
#define AXC_HEADSTAGE_NAME_NONE        @"Not Connected" '   headstage not connected

'  ==============================================================================================
'   Headstage feedback resistor values
'  ==============================================================================================
const as double AXC_HEADSTAGE_RF_ADAPTER_DEFAULT      = 1.0e+6 '   Rf = 1M
const as double AXC_HEADSTAGE_RF_HS9_x10uA            = 1.0e+6 '   Rf = 1M
const as double AXC_HEADSTAGE_RF_HS9_x1uA             = 1.0e+7 '   Rf = 10M
const as double AXC_HEADSTAGE_RF_HS9_x100nA           = 1.0e+8 '   Rf = 100M
const as double AXC_HEADSTAGE_RF_VG9_x10uA            = 1.0e+6 '   Rf = 1M
const as double AXC_HEADSTAGE_RF_VG9_x100uA           = 1.0e+5 '   Rf = 0.1M

'  ==============================================================================================
'   Headstage injection capacitor values
'  =============================================================================================
const as double  AXC_HEADSTAGE_CI_ADAPTER_DEFAULT     = 10.0e-12 '   Ci = 10pF
const as double  AXC_HEADSTAGE_CI_HS9_x10uA           = 10.0e-12 '   Ci = 10pF
const as double  AXC_HEADSTAGE_CI_HS9_x1uA            = 10.0e-12 '   Ci = 10pF
const as double  AXC_HEADSTAGE_CI_HS9_x100nA          = 10.0e-12 '   Ci = 10pF
const as double  AXC_HEADSTAGE_CI_VG9_x10uA           = 10.0e-12 '   Ci = 10pF
const as double  AXC_HEADSTAGE_CI_VG9_x100uA          = 10.0e-12 '   Ci = 10pF

'  ==============================================================================================
'   Audio identifiers
'  ==============================================================================================
const as uinteger AXC_AUDIO_MODE_DIRECT  = 0
const as uinteger AXC_AUDIO_MODE_VCO     = 1

const as uinteger AXC_AUDIO_SIGNAL_I1    = 0  
const as uinteger AXC_AUDIO_SIGNAL_I2    = 2  
const as uinteger AXC_AUDIO_SIGNAL_10V1  = 1  
const as uinteger AXC_AUDIO_SIGNAL_10V2  = 3  

'  ==============================================================================================
'   Audio signal names
'  ==============================================================================================
#define AXC_AUDIO_NAME_I   @"Membrane Current"
#define AXC_AUDIO_NAME_10V @"Membrane Potential"

'  ==============================================================================================
'   Scope identifiers
'  ==============================================================================================
const as uinteger AXC_SCOPE_MODE_DCC          = 0
const as uinteger AXC_SCOPE_MODE_SCLDOUTPUT   = 1 

'  ==============================================================================================
'   Sync output identifiers
'  ==============================================================================================
const as uinteger AXC_SYNCOUTPUT_CH1_OSC      = 0 '   Channel 1 oscillator
const as uinteger AXC_SYNCOUTPUT_CH2_OSC      = 1 '   Channel 2 oscillator
const as uinteger AXC_SYNCOUTPUT_MODE         = 2 '   Amplifier mode

const as uinteger AXC_SYNCOUTPUT_AUTO_DISABLE = 0 '   Sync does not follow active channel
const as uinteger AXC_SYNCOUTPUT_AUTO_OSC     = 1 '   Oscillator sync follows active channel

'  ==============================================================================================
'   string sizes
'  ==============================================================================================
const as uinteger AXC_STRSIZE_SN              = 16  '   serial number string size
const as uinteger AXC_STRSIZE_TX              = 16  '   USB output report string size
const as uinteger AXC_STRSIZE_RX              = 16  '   USB input report string size
const as uinteger AXC_STRSIZE_ERR             = 256 '   error text string size


extern "Windows-MS"

declare function AXC_BuildErrorText (byval hAXC as HAXC, byval nErrorNum as long, byval sTxtBuf as LPSTR, byval uMaxLen as UINT) as BOOL
declare function AXC_CheckAPIVersion(byval pszQueryVersion as LPCSTR) as BOOL
declare function AXC_FindFirstDevice(byval hAXC as HAXC, byval pszSerialNum as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_FindNextDevice (byval hAXC as HAXC, byval pszSerialNum as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_OpenDevice     (byval hAXC as HAXC, byval pszSerialNum as const zstring ptr, byval bReadHardware as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_CloseDevice    (byval hAXC as HAXC, byval pnError as long ptr) as BOOL
declare function AXC_CreateHandle   (byval bDemo as BOOL, byval pnError as long ptr) as HAXC
declare sub      AXC_DestroyHandle  (byval hAXC as HAXC)

end extern


extern "Windows"

declare function AXC_GetSerialNumber alias "_AXC_GetSerialNumber" (byval m_hAXC as HAXC, byval pszSerialNum as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_IsDeviceOpen alias "_AXC_IsDeviceOpen" (byval hAXC as HAXC, byval pbOpen as BOOL ptr, byval pnError as long ptr) as BOOL
declare function AXC_IsDemo alias "_AXC_IsDemo" (byval hAXC as HAXC, byval pbDemo as BOOL ptr, byval pnError as long ptr) as BOOL
declare function AXC_Reset alias "_AXC_Reset" (byval hAXC as HAXC, byval pnError as long ptr) as BOOL

declare function AXC_GetPropertyRules alias "_AXC_GetPropertyRules" (byval hAXC as HAXC, byval pRules as AXC_PropertyRules ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_CalibrateHeadstageProperties alias "_AXC_CalibrateHeadstageProperties" (byval hAXC as HAXC, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_IsHeadstagePresent alias "_AXC_IsHeadstagePresent" (byval hAXC as HAXC, byval pbPresent as BOOL ptr, byval uChannel as UINT, byval bAuxiliary as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_GetHeadstageType alias "_AXC_GetHeadstageType" (byval hAXC as HAXC, byval puType as UINT ptr, byval uChannel as UINT, byval bAuxiliary as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_GetRf alias "_AXC_GetRf" (byval hAXC as HAXC, byval pdRf as double ptr, byval uChannel as UINT, byval bAuxiliary as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_GetCi alias "_AXC_GetCi" (byval hAXC as HAXC, byval pdCi as double ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetCustomHeadstageValues alias "_AXC_SetCustomHeadstageValues" (byval hAXC as HAXC, byval dRf as double, byval dCi as double, byval bEnable as BOOL, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetCustomHeadstageValues alias "_AXC_GetCustomHeadstageValues" (byval hAXC as HAXC, byval pdRf as double ptr, byval pdCi as double ptr, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_LoadProperties alias "_AXC_LoadProperties" (byval hAXC as HAXC, byval pszSettings as LPCSTR, byval pszPath as LPCSTR, byval bUseFile as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_SaveProperties alias "_AXC_SaveProperties" (byval hAXC as HAXC, byval pszSettings as LPCSTR, byval pszPath as LPCSTR, byval bUseFile as BOOL, byval pnError as long ptr) as BOOL

declare function AXC_SetSyncOutput alias "_AXC_SetSyncOutput" (byval hAXC as HAXC, byval uSync as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetSyncOutput alias "_AXC_GetSyncOutput" (byval hAXC as HAXC, byval puSync as UINT ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoSyncOutput alias "_AXC_SetAutoSyncOutput" (byval hAXC as HAXC, byval uAutoSync as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoSyncOutput alias "_AXC_GetAutoSyncOutput" (byval hAXC as HAXC, byval puAutoSync as UINT ptr, byval pnError as long ptr) as BOOL
declare function AXC_GetFirmwareVersion alias "_AXC_GetFirmwareVersion" (byval hAXC as HAXC, byval pszLowVer as zstring ptr, byval pszHiVer as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetDeviceName alias "_AXC_GetDeviceName" (byval hAXC as HAXC, byval pszName as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetManufactureDate alias "_AXC_GetManufactureDate" (byval hAXC as HAXC, byval pszDate as zstring ptr, byval uBufSize as UINT, byval pnError as long ptr) as BOOL
declare function AXC_SetCacheEnable alias "_AXC_SetCacheEnable" (byval hAXC as HAXC, byval bCache as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_SetHardwareAccessEnable alias "_AXC_SetHardwareAccessEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval pnError as long ptr) as BOOL

declare function AXC_SetMeterSignal alias "_AXC_SetMeterSignal" (byval hAXC as HAXC, byval uMeter as UINT, byval uSignal as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetMeterSignal alias "_AXC_GetMeterSignal" (byval hAXC as HAXC, byval uMeter as UINT, byval puSignal as UINT ptr, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_AcquireMeterData alias "_AXC_AcquireMeterData" (byval hAXC as HAXC, byval pMeterData as AXC_MeterData ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetMeterAttenuatorEnable alias "_AXC_SetMeterAttenuatorEnable" (byval hAXC as HAXC, byval uMeter as UINT, byval bAttenuator as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_GetMeterAttenuatorEnable alias "_AXC_GetMeterAttenuatorEnable" (byval hAXC as HAXC, byval uMeter as UINT, byval pbAttenuator as BOOL ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetMode alias "_AXC_SetMode" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetMode alias "_AXC_GetMode" (byval hAXC as HAXC, byval uChannel as UINT, byval puMode as UINT ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoEnable alias "_AXC_SetAutoEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoEnable alias "_AXC_GetAutoEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoPolarity alias "_AXC_SetAutoPolarity" (byval hAXC as HAXC, byval uPolarity as UINT, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoPolarity alias "_AXC_GetAutoPolarity" (byval hAXC as HAXC, byval puPolarity as UINT ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoSource alias "_AXC_SetAutoSource" (byval hAXC as HAXC, byval uSource as UINT, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoSource alias "_AXC_GetAutoSource" (byval hAXC as HAXC, byval puSource as UINT ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoThreshold alias "_AXC_SetAutoThreshold" (byval hAXC as HAXC, byval dThreshold as double, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoThreshold alias "_AXC_GetAutoThreshold" (byval hAXC as HAXC, byval pdThreshold as double ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoThresholdRange alias "_AXC_GetAutoThresholdRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoICReturn alias "_AXC_SetAutoICReturn" (byval hAXC as HAXC, byval uICReturn as UINT, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoICReturn alias "_AXC_GetAutoICReturn" (byval hAXC as HAXC, byval puICReturn as UINT ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoICDelay alias "_AXC_SetAutoICDelay" (byval hAXC as HAXC, byval dDelay as double, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoICDelay alias "_AXC_GetAutoICDelay" (byval hAXC as HAXC, byval pdDelay as double ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoICDelayRange alias "_AXC_GetAutoICDelayRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAutoVCDelay alias "_AXC_SetAutoVCDelay" (byval hAXC as HAXC, byval dDelay as double, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoVCDelay alias "_AXC_GetAutoVCDelay" (byval hAXC as HAXC, byval pdDelay as double ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAutoVCDelayRange alias "_AXC_GetAutoVCDelayRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetHoldingEnable alias "_AXC_SetHoldingEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetHoldingEnable alias "_AXC_GetHoldingEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetHoldingLevel alias "_AXC_SetHoldingLevel" (byval hAXC as HAXC, byval dLevel as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetHoldingLevel alias "_AXC_GetHoldingLevel" (byval hAXC as HAXC, byval pdLevel as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetHoldingRange alias "_AXC_GetHoldingRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetExtCmdEnable alias "_AXC_SetExtCmdEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetExtCmdEnable alias "_AXC_GetExtCmdEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetExtCmdSensit alias "_AXC_GetExtCmdSensit" (byval hAXC as HAXC, byval pdSensit as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetTestSignalEnable alias "_AXC_SetTestSignalEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTestSignalEnable alias "_AXC_GetTestSignalEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetTestSignalAmplitude alias "_AXC_SetTestSignalAmplitude" (byval hAXC as HAXC, byval dAmplitude as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTestSignalAmplitude alias "_AXC_GetTestSignalAmplitude" (byval hAXC as HAXC, byval pdAmplitude as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetTestSignalAmplitudeRange alias "_AXC_GetTestSignalAmplitudeRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_SetTestSignalFrequency alias "_AXC_SetTestSignalFrequency" (byval hAXC as HAXC, byval dFrequency as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetTestSignalFrequency alias "_AXC_GetTestSignalFrequency" (byval hAXC as HAXC, byval pdFrequency as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTestSignalFreqRange alias "_AXC_GetTestSignalFreqRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_Pulse alias "_AXC_Pulse" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetPulseDuration alias "_AXC_SetPulseDuration" (byval hAXC as HAXC, byval dDuration as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPulseDuration alias "_AXC_GetPulseDuration" (byval hAXC as HAXC, byval pdDuration as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetPulseDurationTable alias "_AXC_GetPulseDurationTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetPulseAmplitude alias "_AXC_SetPulseAmplitude" (byval hAXC as HAXC, byval dAmplitude as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPulseAmplitude alias "_AXC_GetPulseAmplitude" (byval hAXC as HAXC, byval pdAmplitude as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPulseAmplitudeRange alias "_AXC_GetPulseAmplitudeRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_Buzz alias "_AXC_Buzz" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_SetBuzzDuration alias "_AXC_SetBuzzDuration" (byval hAXC as HAXC, byval dDuration as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBuzzDuration alias "_AXC_GetBuzzDuration" (byval hAXC as HAXC, byval pdDuration as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBuzzDurationTable alias "_AXC_GetBuzzDurationTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_AutoPipetteOffset alias "_AXC_AutoPipetteOffset" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetPipetteOffsetLock alias "_AXC_SetPipetteOffsetLock" (byval hAXC as HAXC, byval bLock as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPipetteOffsetLock alias "_AXC_GetPipetteOffsetLock" (byval hAXC as HAXC, byval pbLock as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetPipetteOffset alias "_AXC_SetPipetteOffset" (byval hAXC as HAXC, byval dPipetteOffset as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPipetteOffset alias "_AXC_GetPipetteOffset" (byval hAXC as HAXC, byval pdPipetteOffset as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetPipetteOffsetRange alias "_AXC_GetPipetteOffsetRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetOscKillerEnable alias "_AXC_SetOscKillerEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetOscKillerEnable alias "_AXC_GetOscKillerEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetOscKillerMethod alias "_AXC_SetOscKillerMethod" (byval hAXC as HAXC, byval uMethod as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetOscKillerMethod alias "_AXC_GetOscKillerMethod" (byval hAXC as HAXC, byval puMethod as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_AutoBridge alias "_AXC_AutoBridge" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetBridgeEnable alias "_AXC_SetBridgeEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBridgeEnable alias "_AXC_GetBridgeEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetBridgeLock alias "_AXC_SetBridgeLock" (byval hAXC as HAXC, byval bLock as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBridgeLock alias "_AXC_GetBridgeLock" (byval hAXC as HAXC, byval pbLock as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetBridgeLevel alias "_AXC_SetBridgeLevel" (byval hAXC as HAXC, byval dLevel as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBridgeLevel alias "_AXC_GetBridgeLevel" (byval hAXC as HAXC, byval pdLevel as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetBridgeRange alias "_AXC_GetBridgeRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_ClearElectrode alias "_AXC_ClearElectrode" (byval hAXC as HAXC, byval bOn as BOOL, byval uPolarity as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetCapNeutEnable alias "_AXC_SetCapNeutEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetCapNeutEnable alias "_AXC_GetCapNeutEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetCapNeutLevel alias "_AXC_SetCapNeutLevel" (byval hAXC as HAXC, byval dLevel as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetCapNeutLevel alias "_AXC_GetCapNeutLevel" (byval hAXC as HAXC, byval pdLevel as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetCapNeutRange alias "_AXC_GetCapNeutRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetTrackEnable alias "_AXC_SetTrackEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTrackEnable alias "_AXC_GetTrackEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetTrackLevel alias "_AXC_SetTrackLevel" (byval hAXC as HAXC, byval dLevel as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTrackLevel alias "_AXC_GetTrackLevel" (byval hAXC as HAXC, byval pdLevel as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTrackLevelRange alias "_AXC_GetTrackLevelRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetTrackSpeed alias "_AXC_SetTrackSpeed" (byval hAXC as HAXC, byval dSpeed as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTrackSpeed alias "_AXC_GetTrackSpeed" (byval hAXC as HAXC, byval pdSpeed as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetTrackSpeedTable alias "_AXC_GetTrackSpeedTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScaledOutputSignal alias "_AXC_SetScaledOutputSignal" (byval hAXC as HAXC, byval uSignal as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputSignal alias "_AXC_GetScaledOutputSignal" (byval hAXC as HAXC, byval puSignal as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetScaledOutputSignalTable alias "_AXC_GetScaledOutputSignalTable" (byval hAXC as HAXC, byval pSignals as AXC_Signal ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_SetScaledOutputGain alias "_AXC_SetScaledOutputGain" (byval hAXC as HAXC, byval dGain as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetScaledOutputGain alias "_AXC_GetScaledOutputGain" (byval hAXC as HAXC, byval pdGain as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputGainTable alias "_AXC_GetScaledOutputGainTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScaledOutputLPFType alias "_AXC_SetScaledOutputLPFType" (byval hAXC as HAXC, byval uType as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputLPFType alias "_AXC_GetScaledOutputLPFType" (byval hAXC as HAXC, byval puType as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScaledOutputLPF alias "_AXC_SetScaledOutputLPF" (byval hAXC as HAXC, byval dLPF as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputLPF alias "_AXC_GetScaledOutputLPF" (byval hAXC as HAXC, byval pdLPF as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputLPFTable alias "_AXC_GetScaledOutputLPFTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_SetScaledOutputHPF alias "_AXC_SetScaledOutputHPF" (byval hAXC as HAXC, byval dHPF as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputHPF alias "_AXC_GetScaledOutputHPF" (byval hAXC as HAXC, byval pdHPF as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputHPFTable alias "_AXC_GetScaledOutputHPFTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_AutoScaledOutputZero alias "_AXC_AutoScaledOutputZero" (byval hAXC as HAXC, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScaledOutputZeroEnable alias "_AXC_SetScaledOutputZeroEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputZeroEnable alias "_AXC_GetScaledOutputZeroEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScaledOutputZeroLevel alias "_AXC_SetScaledOutputZeroLevel" (byval hAXC as HAXC, byval dZero as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputZeroLevel alias "_AXC_GetScaledOutputZeroLevel" (byval hAXC as HAXC, byval pdZero as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetScaledOutputZeroRange alias "_AXC_GetScaledOutputZeroRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScaledOutputCacheSettings alias "_AXC_GetScaledOutputCacheSettings" (byval hAXC as HAXC, byval pSettings as AXC_SignalSettings ptr, byval uSignal as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_GetSignalScaleFactor alias "_AXC_GetSignalScaleFactor" (byval hAXC as HAXC, byval pdScaleFactor as double ptr, byval uSignal as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetSamplePeriod alias "_AXC_SetSamplePeriod" (byval hAXC as HAXC, byval dPeriod as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetSamplePeriod alias "_AXC_GetSamplePeriod" (byval hAXC as HAXC, byval pdPeriod as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetSamplePeriodRange alias "_AXC_GetSamplePeriodRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetLoopGain alias "_AXC_SetLoopGain" (byval hAXC as HAXC, byval dGain as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetLoopGain alias "_AXC_GetLoopGain" (byval hAXC as HAXC, byval pdGain as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetLoopGainRange alias "_AXC_GetLoopGainRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetLoopLag alias "_AXC_SetLoopLag" (byval hAXC as HAXC, byval dLag as double, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetLoopLag alias "_AXC_GetLoopLag" (byval hAXC as HAXC, byval pdLag as double ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetLoopLagTable alias "_AXC_GetLoopLagTable" (byval hAXC as HAXC, byval pdTable as double ptr, byval puBufSize as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetDCRestoreEnable alias "_AXC_SetDCRestoreEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetDCRestoreEnable alias "_AXC_GetDCRestoreEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetAudioEnable alias "_AXC_SetAudioEnable" (byval hAXC as HAXC, byval bEnable as BOOL, byval pnError as long ptr) as BOOL
declare function AXC_GetAudioEnable alias "_AXC_GetAudioEnable" (byval hAXC as HAXC, byval pbEnable as BOOL ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetAudioGain alias "_AXC_SetAudioGain" (byval hAXC as HAXC, byval uGain as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAudioGain alias "_AXC_GetAudioGain" (byval hAXC as HAXC, byval puGain as UINT ptr, byval pnError as long ptr) as BOOL
declare function AXC_GetAudioGainRange alias "_AXC_GetAudioGainRange" (byval hAXC as HAXC, byval pRange as AXC_PropertyRange ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetAudioMode alias "_AXC_SetAudioMode" (byval hAXC as HAXC, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAudioMode alias "_AXC_GetAudioMode" (byval hAXC as HAXC, byval puMode as UINT ptr, byval pnError as long ptr) as BOOL

declare function AXC_SetAudioSignal alias "_AXC_SetAudioSignal" (byval hAXC as HAXC, byval uSignal as UINT, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetAudioSignal alias "_AXC_GetAudioSignal" (byval hAXC as HAXC, byval puSignal as UINT ptr, byval uChannel as UINT, byval uMode as UINT, byval pnError as long ptr) as BOOL

declare function AXC_SetScopeMode alias "_AXC_SetScopeMode" (byval hAXC as HAXC, byval uMode as UINT, byval pnError as long ptr) as BOOL
declare function AXC_GetScopeMode alias "_AXC_GetScopeMode" (byval hAXC as HAXC, byval puMode as UINT ptr, byval pnError as long ptr) as BOOL

declare function AXC_GetCommandCount alias "_AXC_GetCommandCount" (byval hAXC as HAXC, byval puCount as UINT ptr, byval pnError as long ptr) as BOOL
declare function AXC_GetMeanCommandTime alias "_AXC_GetMeanCommandTime" (byval hAXC as HAXC, byval pdMean as double ptr, byval pnError as long ptr) as BOOL

end extern
